local HavenLootsServer = CreateFrame("Frame", "HavenLootsServer", UIParent, nil);
local mainTexture = "Interface\\AddOns\\HavenLoots\\Textures\\white.tga";
local mainFont = "Fonts\\FRIZQT__.TTF";
RegisterAddonMessagePrefix("HavenLoots");

local sendType = "RAID";
local vCheckData = {};
local timeSinceCheck = 0;

local function IsMasterLooter()
	local _, _, ID = GetLootMethod();
	if ID == nil or UnitName("raid" ..ID) ~= UnitName("player") then
		return false;
	end
	return true;
end

local function SendNewItem()
	local link = GetLootSlotLink(LootFrame.selectedSlot);
	if link == nil then return end
	SendAddonMessage("HavenLoots", "new" .."_" ..link, sendType);
end

local function IsAlt(name)
	words = {}
	for word in name:gmatch("([^-]+)") do table.insert(words, word) end
	for i = 1, table.getn(HavenLootsServer_alts) do
		if HavenLootsServer_alts[i] == words[1] then
			return true;
		end
	end
	return false;
end

local function AddLootRoll(itemLink, name, rollType)
	if IsAlt(name) then
		if rollType < 3 then
			rollType = rollType + 1;
		end
	end
	SendAddonMessage("HavenLoots", "res" .."_" ..name .."_"..rollType .."_" ..math.random(100) + ((5 - rollType) * 100) .."_" ..itemLink, sendType);
end

local function IsAlt(name)
	words = {}
	for word in name:gmatch("([^-]+)") do table.insert(words, word) end
	for i = 1, table.getn(HavenLootsServer_alts) do
		if HavenLootsServer_alts[i] == words[1] then
			return true;
		end
	end
	return false;
end

local function NameIsInRaid(input)
	for i = 1, 40 do
		local name = GetRaidRosterInfo(i);
		if name == input then
			return true;
		end
	end
	return false;
end

local function TakeFromAlt(input)
	for i = 1, table.getn(HavenLootsServer_alts) do
		if HavenLootsServer_alts[i] == input then
			table.remove(HavenLootsServer_alts, i);
			return true;
		end
	end
	return false;
end

local function VersionChecker()
	local latestVersion = 0;
	local latestVersionString = "";
	local latestNames = {};
	local notLatest = {};
	local notInstalled = {};

	for i = 1, table.getn(vCheckData) do
		if tonumber(vCheckData[i].ver) > latestVersion then
			latestVersion = tonumber(vCheckData[i].ver);
			latestVersionString = vCheckData[i].ver;
		end
	end

	for i = 1, table.getn(vCheckData) do
		if tonumber(vCheckData[i].ver) == latestVersion then
			table.insert(latestNames, vCheckData[i].name);
		else
			table.insert(notLatest, vCheckData[i]);
		end
	end

	for i = 1, GetNumGroupMembers() do
		local name = GetUnitName("raid" ..i, false);
		local inlist = false;
		for x = 1, table.getn(vCheckData) do
			if vCheckData[x].name == name then
				inlist = true;
			end
		end
		if inlist ~= true then
			table.insert(notInstalled, name);
		end
	end

	local latestNamesString = "[Haven Loots] Latest Version (" ..latestVersionString.. "): ";
	for i = 1, table.getn(latestNames) do
		latestNamesString = latestNamesString ..latestNames[i] .." ";
	end
	DEFAULT_CHAT_FRAME:AddMessage(latestNamesString, 0, 1, 0);

	local outofDateString = "[Haven Loots] Out of date: ";
	for i = 1, table.getn(notLatest) do
		outofDateString = outofDateString ..notLatest[i].name .." (" ..notLatest[i].ver ..") ";
	end
	DEFAULT_CHAT_FRAME:AddMessage(outofDateString, 1, 1, 0);

	local notInstalledString = "[Haven Loots] Not installed: "
	for i = 1, table.getn(notInstalled) do
		notInstalledString = notInstalledString ..notInstalled[i] .." ";
	end
	DEFAULT_CHAT_FRAME:AddMessage(notInstalledString, 1, 0, 0);
	vCheckData = {};
	HavenLootsServer:SetScript("OnUpdate", nil);
end

local function TimerUpdate(self, elapsed)
	timeSinceCheck = timeSinceCheck + elapsed;
	if timeSinceCheck < 2 then return end
	timeSinceCheck = 0;
	VersionChecker();
	self:SetScript("OnUpdate", nil);
end

SLASH_HAVENLOOTSSERVER1, SLASH_HAVENLOOTSSERVER2 = '/hls', '/havenlootsserver';
local function ChatCommand(msg, editbox)
	words = {}
	for word in msg:gmatch("[^%s]+") do table.insert(words, word) end

	if words[1] == "alt" then
		table.insert(HavenLootsServer_alts, GetUnitName("target", false));
		SendChatMessage("[Haven Loots] You have been marked as an alt! This means you will be given a lower priority on loot rolls. Roll as if you were a main and the addon will do the rest. Whisper me if this is incorrect!", "WHISPER", "Common", GetUnitName("target", true));
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: " ..GetUnitName("target", false) .." added to alts.", 1, 1, 0);

	elseif words[1] == "altremove" then
		local success = TakeFromAlt(GetUnitName("target", false));
		if success then
			SendChatMessage("[Haven Loots] You are no longer marked as an alt. Lucky you!", "WHISPER", "Common", GetUnitName("target", true));
			DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: " ..GetUnitName("target", false) .." cleared from alts.", 1, 1, 0);
		else
			DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: Error! No one in the current list of alts under that name.", 1, 0, 0);
		end

	elseif words[1] == "altclear" then
		alts = {};
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: Alts Cleared", 1, 1, 0);
		SendChatMessage("[Haven Loots] All alts have been reset! If you were one before you aren't now.", "RAID", "Common");

	elseif words[1] == "clear" then
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: Loot table cleared", 1, 1, 0);
		SendAddonMessage("HavenLoots", "clear", sendType);

	elseif words[1] == "check" then
		SendChatMessage("[Haven Loots] Sending a version check!", "RAID", "Common");
		SendAddonMessage("HavenLoots", "check", sendType);
		HavenLootsServer:SetScript("OnUpdate", TimerUpdate);

	elseif words[1] == "send" then
		local link = GetLootSlotLink(words[2]);
		if link == nil then return end
		SendAddonMessage("HavenLoots", "new" .."_" ..link, sendType);
	end
end
SlashCmdList["HAVENLOOTSSERVER"] = ChatCommand;

local function OnEvent(self, event, prefix, message, channel, sender)
	if event == "ADDON_LOADED" then
		if HavenLootsServer_alts == nil then HavenLootsServer_alts = {} end
	elseif event == "OPEN_MASTER_LOOT_LIST" then
		local info = UIDropDownMenu_CreateInfo();
		info.notCheckable = 1;
		info.text = "Hl Roll";
		info.func = SendNewItem;
		UIDropDownMenu_AddButton(info);
	elseif event == "CHAT_MSG_ADDON" then
		words = {}
		for word in message:gmatch("([^_]+)") do table.insert(words, word) end
		if words[1] == "roll" then
			if IsMasterLooter() ~= true then return end
			local itemLink = words[2];
			local rollType = tonumber(words[3]);
			AddLootRoll(itemLink, sender, rollType);
		elseif words[1] == "ver" then
			senderShorts = {}
			for senderShort in sender:gmatch("([^-]+)") do table.insert(senderShorts, senderShort) end
			local dataInsert = {
				name = senderShorts[1],
				ver = words[2],
			};
			table.insert(vCheckData, dataInsert);
		end
	end
end

HavenLootsServer:RegisterEvent("ADDON_LOADED");
HavenLootsServer:RegisterEvent("OPEN_MASTER_LOOT_LIST");
HavenLootsServer:RegisterEvent("CHAT_MSG_ADDON");
HavenLootsServer:SetScript("OnEvent", OnEvent);